if(!org) var org = {};
if(!org.xtc) org.xtc = {};
if(!org.xtc.tp) org.xtc.tp = {};
if(!org.xtc.tp.select) org.xtc.tp.select = {};


org.xtc.tp.select = function(){
  function pub(){};

  var prefTP = null;

  pub.init = function(){
    prefTP = new ThunderPecPrefs();
    prefTP.init();

    var acctMgr = Components.classes["@mozilla.org/messenger/account-manager;1"].getService(Components.interfaces.nsIMsgAccountManager); 
    var accounts = acctMgr.accounts;  
    var tpecAccountList = document.getElementById('tpecAccountList');
    for (var i = 0; i < accounts.Count(); i++) {  
      var account = accounts.QueryElementAt(i, Components.interfaces.nsIMsgAccount);
      if(account.defaultIdentity){
        var newRow = document.createElement("checkbox");
        newRow.setAttribute('label',account.defaultIdentity.email);
        newRow.setAttribute('id',account.defaultIdentity.email);
        newRow.setAttribute('checked',prefTP.exists(account.defaultIdentity.email));
        var newSpacer = document.createElement("spacer");
        tpecAccountList.appendChild(newRow);
        tpecAccountList.appendChild(newSpacer);
      }
    }
  }

  pub.cancel = function(){
    window.close();
    }

  pub.ok = function(){
    var acctMgr = Components.classes["@mozilla.org/messenger/account-manager;1"].getService(Components.interfaces.nsIMsgAccountManager); 
    var accounts = acctMgr.accounts;  
    var tpecAccountList = document.getElementById('tpecAccountList');
    prefTP.clear();
    for (var i = 0; i < accounts.Count(); i++) {  
      var account = accounts.QueryElementAt(i, Components.interfaces.nsIMsgAccount);
      if(account.defaultIdentity){
        var checkbox = document.getElementById(account.defaultIdentity.email);
        if(checkbox.checked)prefTP.addAccount(account.defaultIdentity.email);
      }
    }
    window.close();
  }

  return pub;
}();
